unit Unit6;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.StdCtrls, frxClass, Data.DB,
  DBAccess, MSAccess, MemDS, frxDBSet, frxRich;

type


  TDetailDevisRecord = record
    DPS_SID : string;
    DPS_ID : string;
    DPT_LVL : string;
    DPT_NUM : string;
    DPT_FAMILLE : string;
    DPT_SFAMILLE : string;
    DPT_REF : string;
    DPT_LIBELLE : string;
    DPT_QTE : string;
    UPU_CODE : string;
    DPT_PUVF : string;
    DPT_PTVF : string;

    //class operator Initialize (out Dest: TDetailDevisRecord);
    //class operator Finalize(var Dest: TDetailDevisRecord);
  end;

  TForm6 = class(TForm)
    Button1: TButton;
    frxReport1: TfrxReport;
    PrintDevisClient_M_Frxdb: TfrxUserDataSet;
    PrintDevisClient_D_Frxdb: TfrxUserDataSet;
    PrintDevisRecapGeneral_D_FrxDb: TfrxUserDataSet;
    procedure PrintDevisClient_D_FrxdbGetValue(const VarName: string;
      var Value: Variant);
    procedure PrintDevisClient_M_FrxdbGetValue(const VarName: string;
      var Value: Variant);
    procedure Button1Click(Sender: TObject);
    procedure PrintDevisClient_D_FrxdbNext(Sender: TObject);
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
  end;

var
  Form6: TForm6;
  a1: array [1..10] of TDetailDevisRecord;
  CurIdx : integer = 0;

implementation

{$R *.dfm}

procedure TForm6.Button1Click(Sender: TObject);
begin
    CurIdx := 0;
    with frxReport1 do
    begin
        PrepareReport(true);
        ShowPreparedReport;
    end;
end;

procedure TForm6.PrintDevisClient_D_FrxdbGetValue(const VarName: string;
  var Value: Variant);
begin
    if VarName = 'DPS_SID' then Value := 2
    else if VarName = 'DPS_ID' then Value := 2
    else if VarName = 'DPT_LVL' then Value := 1
    else if VarName = 'DPT_NUM' then Value := AnsiString('NUM' + IntToStr(CurIdx))
    else if VarName = 'DPT_FAMILLE' then Value := AnsiString('Fam' + IntToStr(CurIdx))
    else if VarName = 'DPT_SFAMILLE' then Value := AnsiString('S\Fam' + IntToStr(CurIdx))
    else if VarName = 'DPT_REF' then Value := AnsiString('REF' + IntToStr(CurIdx))
    else if VarName = 'DPT_LIBELLE' then Value := AnsiString('Libelle' + IntToStr(CurIdx))
    else if VarName = 'DPT_QTE' then Value := 1.00
    else if VarName = 'UPU_CODE' then Value := 'UN'
    else if VarName = 'DPT_PUVF' then Value := 10.00
    else if VarName = 'DPT_PTVF' then Value := 10.00;
end;

procedure TForm6.PrintDevisClient_D_FrxdbNext(Sender: TObject);
begin
  inc(CurIdx);
end;

procedure TForm6.PrintDevisClient_M_FrxdbGetValue(const VarName: string;
  var Value: Variant);
begin
    if VarName = 'DEV_REF_PRI_SID' then Value := ansistring('10000');
end;

end.
